Index: varia/src/main/org/jboss/varia/i18n/BundleResolver.java
===================================================================
--- varia/src/main/org/jboss/varia/i18n/BundleResolver.java	(revision 0)
+++ varia/src/main/org/jboss/varia/i18n/BundleResolver.java	(revision 0)
@@ -0,0 +1,154 @@
+/*
+ * JBoss, the OpenSource J2EE webOS
+ * 
+ * Distributable under LGPL license.
+ * See terms of license at gnu.org.
+ */
+package org.jboss.varia.i18n;
+
+import java.beans.FeatureDescriptor;
+import java.util.Iterator;
+import java.util.MissingResourceException;
+import java.util.ResourceBundle;
+
+import javax.el.ELContext;
+import javax.el.ELException;
+import javax.el.ELResolver;
+import javax.el.PropertyNotFoundException;
+import javax.el.PropertyNotWritableException;
+
+/**
+ * A resolver for the unified JSP expression language (EL) which handles 
+ * objects of type ResourceBundle and uses {@link java.text.MessageFormat} for 
+ * string formatting.  
+ * <p>
+ * As with {@link javax.el.ResourceBundleELResolver},  
+ * the "property" name is treated as a key of the ResourceBundle, but 
+ * any subsequent properties are used as arguments to 
+ * {@link java.text.MessageFormat#format(Object)}.  If there is only one 
+ * property, it is used as a key to the ResourceBundle, but the string is 
+ * <b>not</b> passed through MessageFormat.  Thus strings which 
+ * don't require formatting aren't subject to MessageFormat's confusing 
+ * quoting rules.  This is <i>intended</i> to make translator's jobs easier. 
+ * <p>
+ * Similar to {@link javax.el.ResourceBundleELResolver}, missing resources 
+ * will be replaced by the resource key, surrounded by question marks, rather
+ * than throwing an exception.
+ * <p>
+ * For example, assuming "messages" resolves to a ResourceBundle: 
+ * <pre>${messages["There are ''{0}'' bytes free; total memory is ''{1}''"][freeMem][totalMem]}</pre>
+ * will look up the key <code>"There are ''{0}'' bytes free; total memory is ''{1}''"</code> and format
+ * the resulting string with the arguments <code>freeMem</code> and <code>totalMem</code>, ie:
+ * <pre>MessageFormat.format(messages.getString("There are ''{0}'' bytes free; total memory is ''{1}''"), freeMem, totalMem)</pre>
+ * <p>
+ * <pre>${messages["I'm sorry Dave, I'm afraid I can't do that"]}</pre>
+ * will look up the key in the resource bundle without requiring that the apostrophes be doubled:
+ * <pre>messages.getString("I'm sorry Dave, I'm afraid I can't do that")</pre>
+ * @see javax.el.ResourceBundleELResolver
+ * @see java.text.MessageFormat
+ * @author <a href="mailto:sflaniga@redhat.com">Sean Flanigan</a>
+ * @version $$Revision: $$
+ */
+public class BundleResolver extends ELResolver
+{
+   private static final org.jboss.logging.Logger log = org.jboss.logging.Logger.getLogger(BundleResolver.class);
+
+   @Override
+   public Class<?> getCommonPropertyType(ELContext elContext, Object base)
+   {
+      if (base instanceof ResourceBundle)
+      {
+         return String.class;
+      }
+      else if (base instanceof MessageFormatResolver)
+      {
+         return Object.class;
+      }
+      else
+      {
+         return null;
+      }
+   }
+
+   @Override
+   public Iterator<FeatureDescriptor> getFeatureDescriptors(ELContext elContext, Object base)
+   {
+      return null; // we accept any string as a ResourceBundle key, and any object as a MessageFormat arg.
+   }
+
+   @Override
+   public Class<?> getType(ELContext elContext, Object base, Object property) throws NullPointerException,
+         PropertyNotFoundException, ELException
+   {
+      getValue(elContext, base, property); // sets propertyResolved if appropriate
+      if (elContext.isPropertyResolved())
+      {
+         return MessageFormatResolver.class;
+      }
+      else
+      {
+         return null;
+      }
+   }
+   
+   private static String describe(Object arg)
+   {
+      if(arg == null)
+         return null;
+      return "["+arg.getClass().getName()+"] '"+arg+"'";   //$NON-NLS-1$//$NON-NLS-2$//$NON-NLS-3$
+   }
+
+   @Override
+   public Object getValue(ELContext elContext, Object base, Object property) throws NullPointerException,
+         PropertyNotFoundException, ELException
+   {
+      log.debug("getValue("+describe(base)+", "+describe(property)+")");   //$NON-NLS-1$//$NON-NLS-2$//$NON-NLS-3$
+      if (base instanceof ResourceBundle)
+      {
+         elContext.setPropertyResolved(true);
+         ResourceBundle bundle = (ResourceBundle) base;
+         String s;
+         try
+         {
+            s = bundle.getString(property.toString());
+         }
+         catch (MissingResourceException e)
+         {
+            s = I18nUtil.munge(property.toString(), I18nUtil.getRequestLocale());
+//            s = I18nUtil.munge(property.toString(), bundle.getLocale());
+         }
+         return new MessageFormatResolver(s);
+      }
+      else if (base instanceof MessageFormatResolver)
+      {
+         elContext.setPropertyResolved(true);
+         MessageFormatResolver res = (MessageFormatResolver) base;
+         res.addArg(property);
+         return res;
+      }
+      else
+      {
+         return null;
+      }
+   }
+
+   @Override
+   public boolean isReadOnly(ELContext elContext, Object base, Object property) throws NullPointerException,
+         PropertyNotFoundException, ELException
+   {
+      getValue(elContext, base, property); // sets propertyResolved if appropriate
+      return true;
+   }
+
+   @Override
+   public void setValue(ELContext elContext, Object base, Object property, Object value) throws NullPointerException,
+         PropertyNotFoundException, PropertyNotWritableException, ELException
+   {
+      getValue(elContext, base, property); // sets propertyResolved if appropriate
+      if (elContext.isPropertyResolved())
+      {
+         throw new PropertyNotWritableException();
+      }
+   }
+
+}

Index: varia/src/main/org/jboss/varia/i18n/IdentityResourceBundle.java
===================================================================
--- varia/src/main/org/jboss/varia/i18n/IdentityResourceBundle.java	(revision 0)
+++ varia/src/main/org/jboss/varia/i18n/IdentityResourceBundle.java	(revision 0)
@@ -0,0 +1,43 @@
+/*
+ * JBoss, the OpenSource J2EE webOS
+ * 
+ * Distributable under LGPL license.
+ * See terms of license at gnu.org.
+ */
+package org.jboss.varia.i18n;
+
+import java.util.Enumeration;
+import java.util.NoSuchElementException;
+import java.util.ResourceBundle;
+
+/**
+ * This ResourceBundle simply maps keys to themselves.
+ * @author <a href="mailto:sflaniga@redhat.com">Sean Flanigan</a>
+ * @version $$Revision: $$
+ */
+class IdentityResourceBundle extends ResourceBundle
+{
+
+   @Override
+   public Enumeration<String> getKeys()
+   {
+      return new Enumeration<String>()
+      {
+         public boolean hasMoreElements()
+         {
+            return false;
+         }
+         public String nextElement()
+         {
+            throw new NoSuchElementException();
+         }
+      };
+   }
+
+   @Override
+   protected Object handleGetObject(String key)
+   {
+      return key;
+   }
+
+}

Index: varia/src/main/org/jboss/varia/i18n/I18nUtil.java
===================================================================
--- varia/src/main/org/jboss/varia/i18n/I18nUtil.java	(revision 0)
+++ varia/src/main/org/jboss/varia/i18n/I18nUtil.java	(revision 0)
@@ -0,0 +1,188 @@
+/*
+ * JBoss, the OpenSource J2EE webOS
+ * 
+ * Distributable under LGPL license.
+ * See terms of license at gnu.org.
+ */
+package org.jboss.varia.i18n;
+
+import java.lang.reflect.Field;
+import java.lang.reflect.InvocationTargetException;
+import java.lang.reflect.Method;
+import java.util.Locale;
+import java.util.MissingResourceException;
+import java.util.ResourceBundle;
+
+import org.jboss.logging.Logger;
+
+/**
+ * 
+ * @author <a href="mailto:sflaniga@redhat.com">Sean Flanigan</a>
+ * @version $$Revision: $$
+ */
+public class I18nUtil
+{
+   private static final Logger log = Logger.getLogger(I18nUtil.class);
+   // see reloadBundlesHack().
+   private static boolean warnedAboutReload = false;
+   private static Locale defaultLocale;
+
+   public static String munge(String englishKey, Locale locale)
+   {
+      return "???[" + locale + "]" + englishKey + "???"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+   }
+   
+   public static Locale toLocale(String name)
+   {
+      int firstUnderscore = name.indexOf('_');
+      if (firstUnderscore < 0)
+      {
+         return new Locale(name);
+      }
+      String lang = name.substring(0, firstUnderscore);
+      int secondUnderscore = name.indexOf('_', firstUnderscore+1);
+      if (secondUnderscore < 0)
+      {
+         String country = name.substring(firstUnderscore+1);
+         return new Locale(lang, country);
+      }
+      String country = name.substring(firstUnderscore+1, secondUnderscore);
+      String variant = name.substring(secondUnderscore+1);
+      
+      return new Locale(lang, country, variant);
+   }
+   
+   public static Locale getRequestLocale() 
+   {
+      Locale locale = requestLocale.get();
+      if (locale == null)
+      {
+         // This could happen if we are running in the applet, not the web server.
+         // Just fall back on the JVM's default locale.
+         log.debug("unknown locale for request; using default"); //$NON-NLS-1$
+         if (defaultLocale != null)
+            locale = defaultLocale;
+         else
+            locale = Locale.getDefault();
+      }
+      return locale;
+   }
+
+   public static String gettext(String englishKey, String baseName)
+   {
+      Locale locale = getRequestLocale();
+      
+      try
+      {
+         ResourceBundle bundle = ResourceBundle.getBundle(baseName, locale);
+         if (bundle != null)
+         {
+            try
+            {
+               return bundle.getString(englishKey);
+            }
+            catch (java.util.MissingResourceException e)
+            {
+               if(locale.getLanguage().equals(Locale.ENGLISH.getLanguage()))
+               {
+                  return englishKey;
+               }
+               else
+               {
+//                  return munge(englishKey, bundle.getLocale());
+                  return munge(englishKey, locale);
+               }
+            }
+         }
+         return munge(englishKey, locale);
+      }
+      catch (MissingResourceException e)
+      {
+         return munge(englishKey, locale);
+      }
+   }
+
+   // A hack to force all ResourceBundles to be reloaded at dev-time
+   // from here: http://saloon.javaranch.com/cgi-bin/ubb/ultimatebb.cgi?ubb=get_topic&f=7&t=019653
+   static void reloadBundlesHack()
+   {
+      if (!warnedAboutReload)
+      {
+         log.warn("Clearing ResourceBundles: this hurts performance, and should not be enabled in production");
+         warnedAboutReload = true;
+      }
+      try
+      {
+         clearMap(ResourceBundle.class, null, "cacheList"); //$NON-NLS-1$
+         clearClassLoaderCache();
+      }
+      catch (Exception e)
+      {
+         log.warn("Could not reload resource bundles", e);
+      }
+   }
+
+   private static void clearClassLoaderCache()
+   {
+      ClassLoader loader = Thread.currentThread().getContextClassLoader();
+      // no need for compilation here.
+      Class<?> cl = loader.getClass();
+
+      try
+      {
+         if ("org.jboss.web.tomcat.service.WebAppClassLoader".equals(cl.getName())) //$NON-NLS-1$
+         {
+            cl = cl.getSuperclass();
+         }
+         if ("org.apache.catalina.loader.WebappClassLoader".equals(cl.getName())) //$NON-NLS-1$
+         {
+            clearMap(cl, loader, "resourceEntries"); //$NON-NLS-1$
+         }
+         else if ("org.jboss.classloader.spi.base.BaseClassLoader".equals(loader.getParent().getClass().getName())) //$NON-NLS-1$
+         {
+        	 // apparently not needed
+//        	 cl = loader.getParent().getClass();
+//             clearMap(cl, loader.getParent(), "resourceCache"); //$NON-NLS-1$
+         }
+         else
+         {
+            log.info("classloader " + cl.getName() + " is unknown. Parent is "+loader.getParent().getClass().getName());
+         }
+      }
+      catch (Exception e)
+      {
+         log.warn("couldn't clear classloader cache", e);
+      }
+   }
+
+   private static void clearMap(Class<?> cl, Object obj, String name) throws NoSuchFieldException, IllegalAccessException,
+         NoSuchMethodException, InvocationTargetException
+   {
+      Field field = cl.getDeclaredField(name);
+      field.setAccessible(true);
+
+      Object cache = field.get(obj);
+      Class<?> ccl = cache.getClass();
+      Method clearMethod = ccl.getMethod("clear", (Class[]) null); //$NON-NLS-1$
+      clearMethod.invoke(cache, (Object[]) null);
+   }
+
+   static final ThreadLocal<Locale> requestLocale = new ThreadLocal<Locale>();
+
+   static void clearRequestLocale()
+   {
+      I18nUtil.requestLocale.remove();
+   }
+
+   public static void setRequestLocale(final Locale locale)
+   {
+      I18nUtil.requestLocale.set(locale);
+   }
+
+   public static void setLocale(Locale locale)
+   {
+      // not allowed in unsigned applet, so we simulate it:
+//      Locale.setDefault(locale);
+      defaultLocale = locale;
+   }
+}

Index: varia/src/main/org/jboss/jmx/console/I18n.java
===================================================================
--- varia/src/main/org/jboss/jmx/console/I18n.java	(revision 0)
+++ varia/src/main/org/jboss/jmx/console/I18n.java	(revision 0)
@@ -0,0 +1,32 @@
+/*
+ * JBoss, the OpenSource J2EE webOS
+ * 
+ * Distributable under LGPL license.
+ * See terms of license at gnu.org.
+ */
+package org.jboss.jmx.console;
+
+import java.text.MessageFormat;
+
+import org.jboss.varia.i18n.I18nUtil;
+
+/**
+ * Convenience class for accessing the JMX console's resource bundle.
+ * @author <a href="mailto:sflaniga@redhat.com">Sean Flanigan</a>
+ * @version $$Revision: $$
+ */
+public class I18n
+{
+   public static final String BUNDLE = "org.jboss.jmx.console.messages"; //$NON-NLS-1$
+   public static String gettext(String englishKey)
+   {
+      return I18nUtil.gettext(englishKey, BUNDLE);
+   }
+
+   public static String gettext(String englishKey, Object arg)
+   {
+      return MessageFormat.format(gettext(englishKey), arg);
+   }
+
+
+}

Index: varia/src/resources/jmx/html/cluster/index.jsp
===================================================================
--- varia/src/resources/jmx/html/cluster/index.jsp	(revision 73432)
+++ varia/src/resources/jmx/html/cluster/index.jsp	(working copy)
@@ -2,5 +2,5 @@
 <frameset  cols="20%, *">
     <frame name="ClusterIndex" src="ClusteredConsole?action=index" marginwidth="10" marginheight="10" scrolling="auto" frameborder="0">
     <frame name="ClusterNodeView" src="bootstrap.html" marginwidth="10" marginheight="10" scrolling="auto" frameborder="0">
-	<noframes>A frames enabled browser is required for the cluster view</noframes>
+	<noframes>${messages["A frames enabled browser is required for the cluster view"]}</noframes>
 </frameset>
Index: varia/src/resources/jmx/html/cluster/bootstrap.jsp
===================================================================
--- varia/src/resources/jmx/html/cluster/bootstrap.jsp	(revision 73432)
+++ varia/src/resources/jmx/html/cluster/bootstrap.jsp	(working copy)
@@ -1,65 +1,65 @@
 <html>
 <head>
-   <title>Cluster View Bootstrap</title>
+   <title>${messages["Cluster View Bootstrap"]}</title>
    <link rel="stylesheet" href="../style_master.css" type="text/css">
 </head>
 
 <table>
    <tr>
       <td width="250" ><img src="../images/logo.gif" align="left" border="0" alt=""></td>
-      <td><h1>JBoss Cluster Bootstrap</h1></td>
+      <td><h1>${messages["JBoss Cluster Bootstrap"]}</h1></td>
    </tr>
 </table>
 <hr>
 <body>
-The cluster nodes to view need to be specified via some bootstrap mechanism.
-This can be done using any of the following methods.
+${messages["The cluster nodes to view need to be specified via some bootstrap mechanism.
+This can be done using any of the following methods."]}
 
-<h1>Bootstrap Using Naming Discovery</h1>
-This determines the cluster entry point by doing an HAJNDI naming service
+<h1>${messages["Bootstrap Using Naming Discovery"]}</h1>
+${messages["This determines the cluster entry point by doing an HAJNDI naming service
 discovery query. The query may be restricted to a given partition name by
 specifying the name in the PartitionName field.
-If not specified than the first partition to respond will be choosen.
+If not specified than the first partition to respond will be choosen."]}
 <form action="ClusteredConsole?action=bootstrap" method="post" target="ClusterIndex">
 	<input type="hidden" name="bootstrap" value="discovery">
 	<table cellspacing="2" cellpadding="2" border="0">
 	<tr>
-		<td>PartitionName:</td><td><input type="text" name="partition" size="40"></td>
+		<td>${messages["PartitionName:"]}</td><td><input type="text" name="partition" size="40"></td>
 	</tr>
 	<tr>
-		<td>DiscoveryName:</td><td><input type="text" name="discoveryGroup" size="40" value="230.0.0.4"></td>
+		<td>${messages["DiscoveryName:"]}</td><td><input type="text" name="discoveryGroup" size="40" value="230.0.0.4"></td>
 	</tr>
 	<tr>
-		<td>DiscoveryPort:</td><td><input type="text" name="discoveryPort" size="40" value="1102"></td>
+		<td>${messages["DiscoveryPort:"]}</td><td><input type="text" name="discoveryPort" size="40" value="1102"></td>
 	</tr>
 	<tr>
-		<td>DiscoveryTimeout:</td><td><input type="text" name="discoveryTimeout" size="40" value="5000"></td>
+		<td>${messages["DiscoveryTimeout:"]}</td><td><input type="text" name="discoveryTimeout" size="40" value="5000"></td>
 	</tr>
 	<tr>
-		<td><input type="reset" name="reset" value="Clear"></td>
-		<td><input type="submit" name="submit" value="Bootstrap"></td>
+		<td><input type="reset" name="reset" value="${messages['Clear']}"></td>
+		<td><input type="submit" name="submit" value="${messages['Bootstrap']}"></td>
 	</tr>
 	</table>
 </form>
 
-<h1>Bootstrap Using a Hostname</h1>
-This determines the cluster entry point(s) by querying the JNDI service
+<h1>${messages["Bootstrap Using a Hostname"]}</h1>
+${messages['This determines the cluster entry point(s) by querying the JNDI service
 on the indicated server for the available cluster paritition services.
 Any cluster to which the server belongs will serve as an entry point for
 determining the members of the cluster. To query the server hosting the
-jmx-console application use "locahost" for the hostname.
+jmx-console application use "locahost" for the hostname.']}
 <form action="ClusteredConsole" method="post" target="ClusterIndex">
 	<input type="hidden" name="bootstrap" value="byhost">
 	<table cellspacing="2" cellpadding="2" border="0">
 	<tr>
-		<td>Hostname:</td><td><input type="text" name="hostname" value="localhost" size="40"></td>
+		<td>${messages["Hostname:"]}</td><td><input type="text" name="hostname" value="localhost" size="40"></td>
 	</tr>
 	<tr>
-		<td>Port:</td><td><input type="text" name="port" value="1099" size="40"></td>
+		<td>${messages["Port:"]}</td><td><input type="text" name="port" value="1099" size="40"></td>
 	</tr>
 	<tr>
-		<td><input type="reset" name="reset" value="Clear"></td>
-		<td><input type="submit" name="submit" value="Bootstrap"></td>
+		<td><input type="reset" name="reset" value="${messages['Clear']}"></td>
+		<td><input type="submit" name="submit" value="${messages['Bootstrap']}"></td>
 	</tr>
 	</table>
 </form>
Index: varia/src/resources/jmx/html/inspectMBean.jsp
===================================================================
--- varia/src/resources/jmx/html/inspectMBean.jsp	(revision 73826)
+++ varia/src/resources/jmx/html/inspectMBean.jsp	(working copy)
@@ -1,6 +1,7 @@
 <?xml version="1.0"?>
 <%@page contentType="text/html"
    import="java.net.*,java.util.*,javax.management.*,javax.management.modelmbean.*,
+   org.jboss.jmx.console.I18n,
    org.jboss.jmx.adaptor.control.Server,
    org.jboss.jmx.adaptor.control.AttrResultInfo,
    org.jboss.jmx.adaptor.model.*,
@@ -9,6 +10,7 @@
    java.lang.reflect.Array,
            java.io.StringWriter"
 %>
+<%@page isELIgnored="false" %>
 <%! 
     private static final Comparator MBEAN_FEATURE_INFO_COMPARATOR = new Comparator()
     {
@@ -29,13 +31,13 @@
       }
     };
 
-    String sep = System.getProperty("line.separator", "\n");
+    String sep = System.getProperty("line.separator", "\n"); //$NON-NLS-1$ //$NON-NLS-2$
 
     public String fixDescription(String desc)
     {
-      if (desc == null || desc.equals(""))
+      if (desc == null || desc.equals("")) //$NON-NLS-1$
       {
-        return "(no description)";
+        return I18n.gettext("(no description)"); //$NON-NLS-1$
       }
       return desc;
     }
@@ -60,8 +62,8 @@
    }
    public String quoteName(String name)
    {
-      String sname = name.replace("\"", "&quot;");
-      sname = name.replace("\'", "&apos;");
+      String sname = name.replace("\"", "&quot;"); //$NON-NLS-1$ //$NON-NLS-2$
+      sname = name.replace("\'", "&apos;"); //$NON-NLS-1$ //$NON-NLS-2$
       return sname;
    }
 
@@ -73,7 +75,7 @@
 
 <html>
 <head>
-   <title>MBean Inspector</title>
+   <title>${messages["MBean Inspector"]}</title>
    <link rel="stylesheet" href="style_master.css" type="text/css" />
    <meta http-equiv="cache-control" content="no-cache" />
 </head>
@@ -104,7 +106,7 @@
 
 <img src="images/logo.gif" align="right" border="0" alt="" />
 
-<h1>JMX MBean View</h1>
+<h1>${messages["JMX MBean View"]}</h1>
 
 <h3><%= objectNameString %></h3>
 
@@ -114,8 +116,8 @@
 %>
    <table class="ObjectName" cellspacing="0" cellpadding="5">
    <tr>
-      <td class="nameh" rowspan="<%= size + 1 %>">Name</td>
-      <td class='sep'>Domain</td>
+      <td class="nameh" rowspan="<%= size + 1 %>">${messages["Name"]}</td>
+      <td class='sep'>${messages["Domain"]}</td>
       <td class='sep'><%= objectName.getDomain() %></td>
    </tr>
 <%
@@ -133,9 +135,9 @@
    }
 %>
    <tr>
-      <td class='nameh'>Java Class</td>
+      <td class='nameh'>${messages["Java Class"]}</td>
       <td colspan="3"><jsp:getProperty name='mbeanData' property='className'/></td></tr>
-      <tr><td class='nameh'>Description</td>
+      <tr><td class='nameh'>${messages["Description"]}</td>
       <td colspan="3" class="adescription">
          <%= fixDescription(mbeanInfo.getDescription())%>
       </td>
@@ -143,9 +145,9 @@
 </table>
 
 <p>
-<a href='HtmlAdaptor?action=displayMBeans'>Back to Agent View</a>
+<a href='HtmlAdaptor?action=displayMBeans'>${messages["Back to Agent View"]}</a>
 &emsp;
-<a href='HtmlAdaptor?action=inspectMBean&amp;name=<%= URLEncoder.encode(request.getParameter("name")) %>'>Refresh MBean View</a>
+<a href='HtmlAdaptor?action=inspectMBean&amp;name=<%= URLEncoder.encode(request.getParameter("name")) %>'>${messages["Refresh MBean View"]}</a>
 </p>
 
 <form method="post" action="HtmlAdaptor">
@@ -154,11 +156,11 @@
    <table class="AttributesClass" cellspacing="0" cellpadding="5">
       <tr class="AttributesHeader">
       <th width="25%">
-         <span class='aname'>Attribute Name</span> <span class='aaccess'>(Access)</span><br/>
-         <span class='atype'>Type</span> <br/>
-         <span class='adescription'>Description</span> <br/>
+         <span class='aname'>${messages["Attribute Name"]}</span> <span class='aaccess'>${messages["(Access)"]}</span><br/>
+         <span class='atype'>${messages["Type"]}</span> <br/>
+         <span class='adescription'>${messages["Description"]}</span> <br/>
       </th>
-      <th width="75%" class='aname'>Attribute Value</th>
+      <th width="75%" class='aname'>${messages["Attribute Value"]}</th>
       </tr>
 <%
    boolean hasWriteable = false;
@@ -169,7 +171,7 @@
       String attrType = attrInfo.getType();
       AttrResultInfo attrResult = Server.getMBeanAttributeResultInfo(objectNameString, attrInfo);
       String attrValue = attrResult.getAsText();
-      String access = "";
+      String access = ""; //$NON-NLS-1$
       if( attrInfo.isReadable() )
          access += "R";
       if( attrInfo.isWritable() )
@@ -189,16 +191,16 @@
 <%
       if( attrInfo.isWritable() )
       {
-         String readonly = attrResult.editor == null ? "readonly='readonly'" : "";
-         if( attrType.equals("boolean") || attrType.equals("java.lang.Boolean") )
+         String readonly = attrResult.editor == null ? "readonly='readonly'" : ""; //$NON-NLS-1$ //$NON-NLS-2$
+         if( attrType.equals("boolean") || attrType.equals("java.lang.Boolean") ) //$NON-NLS-1$ //$NON-NLS-2$
          {
             // Boolean true/false radio boxes
             Boolean value = Boolean.valueOf(attrValue);
-            String trueChecked = (value == Boolean.TRUE ? "checked='checked'" : "");
-            String falseChecked = (value == Boolean.FALSE ? "checked='checked'" : "");
+            String trueChecked = (value == Boolean.TRUE ? "checked='checked'" : ""); //$NON-NLS-1$ //$NON-NLS-2$
+            String falseChecked = (value == Boolean.FALSE ? "checked='checked'" : ""); //$NON-NLS-1$ //$NON-NLS-2$
 %>
-            <input type="radio" name="<%= attrName %>" value="True" <%=trueChecked%>/>True
-            <input type="radio" name="<%= attrName %>" value="False" <%=falseChecked%>/>False
+            <input type="radio" name="<%= attrName %>" value="True" <%=trueChecked%>/>${messages["True"]}
+            <input type="radio" name="<%= attrName %>" value="False" <%=falseChecked%>/>${messages["False"]}
 <%
          }
          else if( attrInfo.isReadable() )
@@ -244,15 +246,15 @@
             }
          }
          // Array of some objects
-         else if( attrType.startsWith("["))
+         else if( attrType.startsWith("[")) //$NON-NLS-1$
          {
             Object arrayObject = Server.getMBeanAttributeObject(objectNameString, attrName);
             if (arrayObject != null) {
-               out.print("<pre>");
+               out.print("<pre>"); //$NON-NLS-1$
                for (int i = 0; i < Array.getLength(arrayObject); ++i) {
                   out.println(fixValue(Array.get(arrayObject,i)));
                }
-               out.print("</pre>");
+               out.print("</pre>"); //$NON-NLS-1$
             } 
             
          }
@@ -271,7 +273,7 @@
          {
 %>
             <br />
-            <a href="HtmlAdaptor?action=inspectMBean&amp;name=<%= URLEncoder.encode(attrValue) %>">View MBean</a>
+            <a href="HtmlAdaptor?action=inspectMBean&amp;name=<%= URLEncoder.encode(attrValue) %>">${messages["View MBean"]}</a>
 <%
          }
       }
@@ -286,7 +288,7 @@
 %>
    <tr>
       <td colspan='2'>
-         <input class='applyb' type="submit" value="Apply Changes" />
+         <input class='applyb' type="submit" value="${messages['Apply Changes']}" />
       </td>
    </tr>
 <%
@@ -302,12 +304,12 @@
 <table class="AttributesClass" cellspacing="0" cellpadding="5">
    <tr class="AttributesHeader">
    <th width="25%">
-      <span class='aname'>Operation Name</span><br/>
-      <span class='atype'>Return Type</span> <br/>
-      <span class='adescription'>Description</span> <br/>
+      <span class='aname'>${messages["Operation Name"]}</span><br/>
+      <span class='atype'>${messages["Return Type"]}</span> <br/>
+      <span class='adescription'>${messages["Description"]}</span> <br/>
    </th>
    <th width="75%">
-      <span class='aname'>Parameters</span>
+      <span class='aname'>${messages["Parameters"]}</span>
    </th>
    </tr>
 <%
@@ -318,8 +320,8 @@
       if (opInfo instanceof ModelMBeanOperationInfo)
       {
          Descriptor desc = ((ModelMBeanOperationInfo)opInfo).getDescriptor();
-         String role = (String)desc.getFieldValue("role");
-         if ("getter".equals(role) || "setter".equals(role))
+         String role = (String)desc.getFieldValue("role"); //$NON-NLS-1$
+         if ("getter".equals(role) || "setter".equals(role)) //$NON-NLS-1$ //$NON-NLS-2$
          {
             accept = false;
          }
@@ -353,7 +355,7 @@
                String ptype = paramInfo.getType();
                if( pname == null || pname.length() == 0 || pname.equals(ptype) )
                {
-                  pname = "arg"+p;
+                  pname = "arg"+p; //$NON-NLS-1$
                }
                String pdesc = fixDescription(paramInfo.getDescription());
 %>
@@ -363,12 +365,12 @@
          <span class='atype'><%= ptype %></span> <br/>
          <span class='adescription'><%= pdesc %></span> <br/>
 <%
-                if( ptype.equals("boolean") || ptype.equals("java.lang.Boolean") )
+                if( ptype.equals("boolean") || ptype.equals("java.lang.Boolean") ) //$NON-NLS-1$ //$NON-NLS-2$
                 {
                    // Boolean true/false radio boxes
 %>
-            <input type="radio" name="arg<%= p%>" value="True" checked='checked'>True
-            <input type="radio" name="arg<%= p%>" value="False" />False
+            <input type="radio" name="arg<%= p%>" value="True" checked='checked'>${messages["True"]}
+            <input type="radio" name="arg<%= p%>" value="False" />${messages["False"]}
 <%
                  }
                  else
@@ -387,7 +389,7 @@
 <%
          } // has parameter list
 %>
-      <input type="submit" value="Invoke" />
+      <input type="submit" value="${messages['Invoke']}" />
       </form>
 
 </td></tr>
